#!/usr/local/bin/python3

# Read the sample rate used by SqueezeLite through a named pipe
import io
import os
import stat
import subprocess
import sys
from websocket import create_connection

pipe = '/var/run/squeezelite-log.fifo'
config_path = "/home/tc/camilladsp/"
ws_port="1234"

if len(sys.argv) > 1:
    sqLOGFILE = sys.argv[1]
else:
    sqLOGFILE = ""

with open(pipe, 'r') as fifo:
    for line in fifo:
        # Write to log file
        if sqLOGFILE:
            # sys.stdout.write(line)
            with io.open(sqLOGFILE, 'a', encoding='utf-8') as outf:
                outf.write(line)
        
        # Update Camilladsp config
        if "output_frames:149 track start sample rate:" in line:
            word_list = line.split()
            sample_rate = word_list[6]
            send_cfg = '{"SetConfigName": "' + config_path + sample_rate + '.yml"}'
            # print ("send_cfg: " + send_cfg)
            ws = create_connection("ws://127.0.0.1:" + ws_port)
            ws.send(send_cfg)
            ws.recv()
            ws.send('"Reload"')
            ws.recv()
            ws.close()
